class Metric

  attr_accessor :namespace
  attr_accessor :name
  attr_accessor :value
  attr_accessor :unit
  attr_accessor :dimensions
  attr_accessor :timestamp

  def initialize(attributes = {})
    attributes.each do |name, value|
      public_send("#{name}=", value)
    end
    self.timestamp ||= Time.now.utc
  end

  def inspect
    ts = timestamp.iso8601 if timestamp
    {
      namespace: namespace,
      name: name,
      value: value,
      unit: unit,
      dimensions: dimensions,
      timestamp: ts
    }.reject{|_,v| v.nil?}
  end

end
